/*
 * BoundInBoxAction.cpp
 *
 *  Created on: May 8, 2010
 *      Author: heber
 */

#include "Actions/WorldAction/BoundInBoxAction.hpp"
#include "CommandLineParser.hpp"
#include "log.hpp"
#include "molecule.hpp"
#include "World.hpp"

#include <iostream>
#include <string>
#include <vector>

using namespace std;

#include "UIElements/UIFactory.hpp"
#include "UIElements/Dialog.hpp"
#include "Actions/MapOfActions.hpp"

const char WorldBoundInBoxAction::NAME[] = "bound-in-box";

WorldBoundInBoxAction::WorldBoundInBoxAction() :
  Action(NAME)
{}

WorldBoundInBoxAction::~WorldBoundInBoxAction()
{}

Action::state_ptr WorldBoundInBoxAction::performCall() {
  Dialog *dialog = UIFactory::getInstance().makeDialog();

  dialog->queryEmpty(NAME, MapOfActions::getInstance().getDescription(NAME));

  if(dialog->display()) {
    // center
    vector<molecule*> AllMolecules = World::getInstance().getAllMolecules();
    for (vector<molecule*>::iterator MolRunner = AllMolecules.begin(); MolRunner != AllMolecules.end(); ++MolRunner) {
      (*MolRunner)->BoundInBox();
    }
    delete dialog;
    return Action::success;
  } else {
    delete dialog;
    return Action::failure;
  }
}

Action::state_ptr WorldBoundInBoxAction::performUndo(Action::state_ptr _state) {
//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());

  return Action::failure;
//  string newName = state->mol->getName();
//  state->mol->setName(state->lastName);
//
//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
}

Action::state_ptr WorldBoundInBoxAction::performRedo(Action::state_ptr _state){
  return Action::failure;
}

bool WorldBoundInBoxAction::canUndo() {
  return false;
}

bool WorldBoundInBoxAction::shouldUndo() {
  return false;
}

const string WorldBoundInBoxAction::getName() {
  return NAME;
}
